//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"


#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  clrBlue
#property indicator_color2  clrRed
#property indicator_color3  clrBlue
#property indicator_color4  clrRed
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  1

//
//
//
//
//

extern int    Length          = 7;       // Price Channel Period
extern double Risk            = 3;       // Risk Factor in units (0...10) 
extern bool   UseReEntry      = true;    // Re-Entry Mode: 0-off,1-on
extern int    SmoothLength    = 3;
extern double SmoothPhase     = 5;
extern int    Price           = 0;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;
extern string soundfile       = "alert2.wav"; 

//
//
//
//
//

double UpSignal[];
double DnSignal[]; 
double UpEntry[];
double DnEntry[]; 
double smax[];
double smin[];
double trend[];

//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,UpSignal); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,108); SetIndexLabel(0,"UpSignal");
   SetIndexBuffer(1,DnSignal); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,108); SetIndexLabel(1,"DnSignal");
   SetIndexBuffer(2,UpEntry);  SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,241); SetIndexLabel(2,"UpRe-Entry");
   SetIndexBuffer(3,DnEntry);  SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,242); SetIndexLabel(3,"DnRe-Entry");
   SetIndexBuffer(4,smax);
   SetIndexBuffer(5,smin);
   SetIndexBuffer(6,trend);
   IndicatorShortName("PriceChannel_Signal jurik("+Length+")");
return(0);
}

//
//
//
//
//

int start()
{
   
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
         
   for(i=limit; i>=0; i--)
   {   
     double price  = iSmooth(iMA(NULL,0,1,0,MODE_SMA,   Price,i  ),    SmoothLength,SmoothPhase,i,   0);
     double price1 = iSmooth(iMA(NULL,0,1,0,MODE_SMA,   Price,i+1),    SmoothLength,SmoothPhase,i+1,10);
     double hi     = iSmooth(High[iHighest(NULL,0,MODE_HIGH,Length,i)],SmoothLength,SmoothPhase,i,  20);   
     double lo     = iSmooth(Low[iLowest(NULL,  0,MODE_LOW, Length,i)],SmoothLength,SmoothPhase,i,  30); 
     smax[i] = hi - (33-Risk)*(hi-lo)/100;
     smin[i] = lo + (33-Risk)*(hi-lo)/100;
   
     trend[i] = trend[i+1]; 
	       if (price > smax[i]) trend[i] = 1; 
	       if (price < smin[i]) trend[i] =-1;
	
	  //
	  //
	  //
	  //
	  //
	     
	  DnSignal[i] = EMPTY_VALUE;
     DnEntry[i]  = EMPTY_VALUE;
     UpEntry[i]  = EMPTY_VALUE;
     UpSignal[i] = EMPTY_VALUE;

        if (trend[i]>0)
	     {
	       if (trend[i+1]<0)                                                                       UpSignal[i] = Low[i]-0.5*iATR(NULL,0,Length,i);
	       if (UseReEntry && price > smax[i] && price1 <= smax[i+1] && UpSignal[i] == EMPTY_VALUE) UpEntry[i]  = Low[i]-0.5*iATR(NULL,0,Length,i); 
	     }
	     if (trend[i]<0)
	     {
	       if (trend[i+1]>0)                                                                        DnSignal[i] = High[i]+0.5*iATR(NULL,0,Length,i);
	       if (UseReEntry && price < smin[i] && price1 >= smin[i+1] && DnSignal[i] == EMPTY_VALUE)  DnEntry[i]  = High[i]+0.5*iATR(NULL,0,Length,i); 
	     }
   	         

	}
	
	//
	//
	//
	//
	//
	
	if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
  
      if (UpSignal[whichBar] != EMPTY_VALUE && UpSignal[whichBar+1] == EMPTY_VALUE) doAlert(whichBar,"up");
      if (DnSignal[whichBar] != EMPTY_VALUE && DnSignal[whichBar+1] == EMPTY_VALUE) doAlert(whichBar,"down");
      if (UpEntry[whichBar]  != EMPTY_VALUE && UpEntry[whichBar+1]  == EMPTY_VALUE) doAlert(whichBar,"Re-entry for buy");
      if (DnEntry[whichBar]  != EMPTY_VALUE && DnEntry[whichBar+1]  == EMPTY_VALUE) doAlert(whichBar,"Re-entry for sell");       
   } 	         

   return(0);
}

//+------------------------------------------------------------------+
//
//
//
//
    
double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

  
double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," PriceChannel Signal ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " PriceChannel Signal "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

  

